#ifndef HW6_H
#define HW6_H 1

#include "int_list.h"

/* Model: signal = sin(phase + frequency*time) */
typedef struct {
  int channel;
  double frequency;
  double phase;
} channel_params;

// Write an array of channel_params to the named file
void save_channel_params(char *file_name, channel_params *ca, int n_ca);

// Load an array of channel_params from the named file; set n_loaded
// to the number of loaded channel_params; return a pointer to the
// dynamically allocated array
channel_params * load_channel_params(char *file_name, int *n_loaded);

// Insert new data into a list at the given index. Return 1 on
// successful insertion or 0 if the insertion point is out of bounds.
int int_list_insert(int_list *l, int index, int new_val);

// Breaks time down into 12-hour format
typedef struct{
  int hours;
  int minutes;
  int seconds;
  int ispm;
} tod_t;

tod_t time_breakdown(int time_of_day);

int display_bits_from_tod(tod_t tod);

void lcd_update();

#endif
