/* List Functions */

#ifndef INT_LIST_H
#define INT_LIST_H

#include <stdio.h>

typedef struct int_node_struct {
  int data;
  struct int_node_struct *next;
} int_node;

typedef struct {
  int_node *head;
} int_list;

// Create a list of size 0 and return it
int_list* int_list_create();

// Destroy int_list
void int_list_destroy(int_list* v);

// Return number of elements within int_list
int int_list_size(int_list* v);

// Return element at specified index
int int_list_get(int_list* v, int index);

// Set element at specified index
void int_list_set(int_list* v, int index, int new_val);

// Prepend a new element to the beginning of the list
void int_list_prepend(int_list *v, int new_elem);

// Print an int list to the file handle given
void int_list_print(int_list *list, FILE* fout);

// Remove node at given index
int int_list_remove(int_list *l, int index);

// Get element at specified index
int int_list_get(int_list *l, int index);

#endif
